<script setup lang="ts">
import { onMounted, ref } from 'vue';
import { useRouter } from 'vue-router'; // Importar Vue Router para la navegación

// Estado para almacenar qué grupo está expandido (almacenamos el ID del grupo expandido)
const expandedGroup = ref<number | null>(null);

// JSON que contiene las URLs de Grafana cargado desde localStorage
const grafanaPanels = ref([]);

// Estado para verificar si hay datos cargados en localStorage
const hasData = ref(false);

// Router para manejar la navegación
const router = useRouter();

const grafanaUrl = window.GRAFANA_URI;

// Función para cargar el JSON desde localStorage
const loadDashboardsFromLocalStorage = () => {
  const storedData = localStorage.getItem('dashboards');
  if (storedData) {
    grafanaPanels.value = JSON.parse(storedData);
    hasData.value = true;
  } else {
    hasData.value = false;
    console.warn('No hay datos disponibles en localStorage.');
  }
};

// Función para redirigir a la página de carga de JSON
const goToLoadJson = () => {
  router.push('/load_json'); // Redirige a una ruta donde se cargue el JSON
};

// Función para actualizar el valor del checkbox y guardarlo en localStorage
const updatePanelView = (title: string, index: number, field: string, newValue: boolean) => {
  const panelGroup = grafanaPanels.value.find((group: any) => group.title === title);

  if (panelGroup && panelGroup.panels && panelGroup.panels[index]) {
    // Actualiza el valor del campo correspondiente (dashboard_view o home_view)
    panelGroup.panels[index][field] = newValue;

    // Mostrar por consola qué panel está siendo actualizado y su nuevo valor
    console.log(`Actualizando ${field} en el panel ${panelGroup.panels[index].id} del grupo ${title}: ${newValue}`);

    // Guardar los cambios en localStorage
    localStorage.setItem('dashboards', JSON.stringify(grafanaPanels.value));
    console.log('Data updated on localStorage:', grafanaPanels.value);
  } else {
    console.warn(`Grupo o panel no encontrado: ${title}`);
  }
};

// Configuración de eventos y temporizador en la carga del componente
onMounted(() => {
  loadDashboardsFromLocalStorage(); // Cargar los paneles desde localStorage
});

// Definición de encabezados para la tabla
const headers = [
  { title: 'Click to open / close', key: 'data-table-group' },
];
const groupBy = [{ key: 'title' }];

// Función para manejar la expansión de los grupos
const toggleGroupExpansion = (groupId: number) => {
  expandedGroup.value = expandedGroup.value === groupId ? null : groupId;
  const expandedPanelGroup = grafanaPanels.value.find((group: any) => group.id === groupId);

  if (expandedPanelGroup && expandedPanelGroup.panels) {
    expandedPanelGroup.panels.forEach((panel: any) => {
      console.log(`Panel ID: ${panel.id}, Home View: ${panel.home_view}, Dashboard View: ${panel.dashboard_view}`);
    });
  }
};

// Obtener el icono de expansión
const getIcon = (props: Record<string, unknown>) => props.icon as any;
</script>

<template>
  <div>
    <!-- Mostrar mensaje si no hay datos en localStorage -->
    <div v-if="!hasData" class="no-data-container">
      <p>No hay datos cargados. Por favor, carga el JSON.</p>
      <VBtn @click="goToLoadJson" color="primary">
        Cargar JSON
      </VBtn>
    </div>

    <!-- Mostrar la tabla si hay datos en localStorage -->
    <div v-else>
      <VDataTable
        :headers="headers"
        :items="grafanaPanels"
        :items-per-page="30"
        :group-by="groupBy"
      >
        <!-- Slot para personalizar el grupo expandido -->
        <template #data-table-group="{ props, item }">
          <td>
            <VBtn
              v-bind="props"
              variant="text"
              density="comfortable"
              @click="toggleGroupExpansion(item.items[0].raw.id)" 
            >
              <VIcon
                class="flip-in-rtl"
                :icon="getIcon(props)"
              />
            </VBtn>
            <span>{{ item?.value }} ({{ item.items[0].raw.panels.length }})</span>

            <!-- Mostrar iframe y checkbox solo si el grupo está expandido -->
            <div v-if="expandedGroup === item.items[0].raw.id" class="iframe-container">
              <div v-if="item.items[0].raw.panels && item.items[0].raw.panels.length">
                <!-- Iterar sobre los paneles -->
                <div v-for="(panel, index) in item.items[0].raw.panels" :key="panel.id">
                  <div>
                    
                    <!-- Mostrar checkboxes para cada panel -->
                    <div class="checkbox-container">
                      <v-checkbox
                        v-model="panel.dashboard_view"
                        :label="`Dashboard view`"
                        @change="updatePanelView(item.items[0].raw.title, index, 'dashboard_view', panel.dashboard_view)"
                      />
                      <v-checkbox
                        v-model="panel.home_view"
                        :label="`Home view`"
                        @change="updatePanelView(item.items[0].raw.title, index, 'home_view', panel.home_view)"
                      />
                    </div>

                    <!-- Mostrar iframe correspondiente al panel -->
                    <iframe
                      :src="`${grafanaUrl}${item.items[0].raw.url}?orgId=1&refresh=30s&viewPanel=${panel.id}&kiosk`"
                      frameborder="0"
                      style="width: 100%; height: 330px; margin-top: 10px;"
                    ></iframe>
                  </div>
                </div>
              </div>
            </div>
          </td>
        </template>
      </VDataTable>
    </div>
  </div>
</template>



<style scoped>
.no-data-container {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  margin-top: 50px;
}

.iframe-container {
  margin-top: 10px;
  width: 100%;
}

.grafana-iframe {
  width: 100%;
  height: 330px;
  margin-bottom: 16px;
}

.checkbox-container {
  display: flex;
  align-items: center;
  gap: 16px;
  margin-bottom: 10px; /* Espacio entre los checkboxes y el iframe */
}
</style>
